' --------------------------------------------------------------------------------------
'
' Card.VB                                                         Ulrich Mller 19.09.02
'                                                                 PCS1700   VB.NET Final
'
' Klassen zur Erstellung von Patiencen auf Basis von QCard32.DLL (QCard32Wrapper)
' Klassen fr einzelne Karten
'
' --------------------------------------------------------------------------------------

' Card ---------------------------------------------------------------------------------
'      zu verarbeitende Karte
'      KartenNr 1 - 52 bei einem Spiel, 1 - 104 bei zwei Spielen
'      Koordinatensysteme : Pixel bezogen auf die linke obere Ecke der Spielflche 0,0
'                      Matrixposition (0 beginnend) bezogen auf die zugehrende Area
' --------------------------------------------------------------------------------------

Public Structure CardPos
  Public CardNr As Integer
  Public Area As AreaCode
  Public PicX As Integer
  Public PicY As Integer
  Public PosC As Integer
  Public PosR As Integer
End Structure

Public Class Card
  Private qc As QCard32Pool
  Private Nr, X, Y As Integer

  Sub New(ByVal QCard As QCard32Pool, ByVal CardNr%)
    qc = QCard
    Nr = CardNr
  End Sub

  Public ReadOnly Property CardNr() As Integer
    Get
      Return Nr
    End Get
  End Property

  Public Property PicX() As Integer
    Get
      Return X
    End Get
    Set(ByVal Value%)
      X = Value
    End Set
  End Property
  Public Property PicY() As Integer
    Get
      Return Y
    End Get
    Set(ByVal Value%)
      Y = Value
    End Set
  End Property

  Public Property Area() As AreaCode
    Get
      Return qc.GetUser2(Nr)
    End Get
    Set(ByVal Value As AreaCode)
      qc.SetUser2(Nr, Value)
    End Set
  End Property

  Public Property PosC() As Integer
    Get
      Return qc.GetUser3(Nr)
    End Get
    Set(ByVal Value As Integer)
      qc.SetUser3(Nr, Value)
    End Set
  End Property
  Public Property PosR() As Integer
    Get
      Return qc.GetUser4(Nr)
    End Get
    Set(ByVal Value As Integer)
      qc.SetUser4(Nr, Value)
    End Set
  End Property

  Public Property Blocked() As Boolean
    Get
      Return qc.GetCardBlocked(Nr)
    End Get
    Set(ByVal Value As Boolean)
      qc.AdjustCardBlocked(Nr, Value)
    End Set
  End Property

  Public Property Disabled() As Boolean
    Get
      Return qc.IsCardDisabled(Nr)
    End Get
    Set(ByVal Value As Boolean)
      qc.SetCardDisabled(Nr, Value)
    End Set
  End Property

  Public Property Face() As Boolean
    Get
      Return qc.GetCardStatus(Nr)
    End Get
    Set(ByVal Value As Boolean)
      qc.SetCardStatus(Nr, Value)
    End Set
  End Property

  Public ReadOnly Property Suit() As Integer
    Get
      Return qc.GetCardSuit(Nr)
    End Get
  End Property

  Public ReadOnly Property Color() As Integer
    Get
      Return qc.GetCardColor(Nr)
    End Get
  End Property

  Public ReadOnly Property Value() As Integer
    Get
      Return qc.GetCardValue(Nr)
    End Get
  End Property

End Class
