' --------------------------------------------------------------------------------------
'
' Keller.VB                                                       Ulrich Mller 19.09.02
'                                                                 PCS1700   VB.NET Final
'
' Klassen zur Erstellung von Patiencen auf Basis von QCard32.DLL (QCard32Wrapper)
' Klassen fr den Keller
'
' --------------------------------------------------------------------------------------

' LiFoStack ----------------------------------------------------------------------------
' Keller : Einfacher LiFoStack. Auslage nach rechts, Breite whlbar, Null ist mglich
' --------------------------------------------------------------------------------------

Public Class LiFoStack

  Private qc As QCard32Pool
  Private actCard%
  Private Cards(103) As Card
  Private XBasis%, YBasis%, XBreite%, XOffset%
  Dim i As Integer

  ' New ------------------------------------------------------------------------------
  '     Konstruktor
  ' ----------------------------------------------------------------------------------
  Sub New(ByVal QCard As QCard32Pool, ByVal Left%, ByVal Top%)
    ' --- Alle Karten aufeinander ----------------------------
    qc = QCard
    actCard = -1
    XOffset = 0
    XBasis = Left
    YBasis = Top
    XBreite = qc.CardWidth
  End Sub
  Sub New(ByVal QCard As QCard32Pool, ByVal MaxCards%, ByVal Left%, ByVal Top%, _
                                                                     ByVal Width%)
    ' --- Karten nach rechts geschuppt -------------------------------------------
    qc = QCard
    actCard = -1
    XBasis = Left
    YBasis = Top
    XBreite = Width
    XOffset = Int((XBreite - qc.CardWidth) / (MaxCards - 1))
  End Sub

  ' Clear ----------------------------------------------------------------------------
  '       Lschen des Kellers
  ' ----------------------------------------------------------------------------------
  Public Sub Clear()
    actCard = -1
    Paint()
  End Sub

  ' Left / Top ----------------------------------------------------------------
  '                   Lesen der Koordinaten der linken, oberen Ecke
  ' ----------------------------------------------------------------------------------
  Public ReadOnly Property Left() As Integer
    Get
      Return XBasis
    End Get
  End Property
  Public ReadOnly Property Top() As Integer
    Get
      Return YBasis
    End Get
  End Property

  ' Range -----------------------------------------------------------------------------
  '       Lesen der Bereichswerte von LiFoStack
  ' -----------------------------------------------------------------------------------
  Public ReadOnly Property Range() As Rectangle
    Get
      Return New Rectangle(XBasis, YBasis, XBreite, qc.CardHeight)
    End Get
  End Property

  ' TopMostCard -----------------------------------------------------------------------
  '             Lesen der obersten Karte des Kellers
  ' -----------------------------------------------------------------------------------
  Public ReadOnly Property TopMostCard() As Card
    Get
      If actCard < 0 Then Return Nothing Else Return Cards(actCard)
    End Get
  End Property

  ' RemoveCard -----------------------------------------------------------------------
  '            Entfernen der obersten Karte des Kellers
  ' ----------------------------------------------------------------------------------
  Public Function RemoveCard() As Card
    If actCard < 0 Then Return Nothing
    qc.RemoveCard(Cards(actCard).CardNr)
    If actCard > 0 Then Cards(actCard - 1).Disabled = False
    actCard -= 1
    Return Cards(actCard + 1)
  End Function

  ' AddCard --------------------------------------------------------------------------
  '         SrcCard auf dem Keller ablegen
  ' ----------------------------------------------------------------------------------
  Public Sub AddCard(ByVal SrcCard As Card)
    actCard += 1
    Cards(actCard) = SrcCard
    SrcCard.PicX = actCard * XOffset + XBasis
    SrcCard.PicY = YBasis
    SrcCard.Area = AreaCode.Keller
    SrcCard.PosC = 0
    SrcCard.PosR = actCard
    If actCard > 0 Then Cards(actCard - 1).Disabled = True
    qc.DealCard(SrcCard.CardNr, SrcCard.PicX, YBasis)
    SrcCard.Disabled = False
  End Sub

  ' Paint ----------------------------------------------------------------------------
  '       Zeichnen des Kartenbildes
  ' ----------------------------------------------------------------------------------
  Public Sub Paint()
    If actCard < 0 Then
      qc.DrawSymbol(3, XBasis, YBasis)
    Else
      For i = 0 To actCard
        qc.DrawCard(Cards(i).CardNr, Cards(i).PicX, Cards(i).PicY)
      Next
    End If
  End Sub
End Class
