' --------------------------------------------------------------------------------------
'
' PotiPat.VB                                                      Ulrich Mller 12.09.02
'                                                                 PCS1700   VB.NET Final
'
' Klassenbibliothek zur Erstellung von Patiencen auf Basis von QCard32.DLL
' PotiPatience : Abstrakte Klasse als Basis fr Spiele
' Ablage48     : Ablage mit 4/8 Ablagepltzen in Reihe mit Mittellcke (bei 8 Pltzen)
' AuslageV     : Auslage in bis zu 13 Leitern, absteigend, wechselnde Farbe, blocked
'                alt : Auslage10
' LiFoStack    : Keller als einfacher LiFo Stack, Schuppung nach rechts, auch ohne
' KartenPaket  : Gemischtes Kartenpaket und gleichzeitig Talon
' Card         : Daten einer Karte (statische und dynamische)
'
' --------------------------------------------------------------------------------------

Public Enum AreaCode As Integer
  none = 0
  Ablage = 1
  Auslage = 2
  Keller = 3
  Talon = 4
End Enum

' PotiPatience ----------------------------------------------------------------------
'
' Abstrakte Klasse fr die Spiellogik einer Patience
'
' -----------------------------------------------------------------------------------

Public MustInherit Class PotiPatience

  ' --- Protected Felder ---------------------------------------------
  Protected Enum DragCode As Integer
    None = 0
    One = 1
    Block = 2
  End Enum

  Protected qc As QCard32Pool
  Protected Canvas As System.Windows.Forms.Form
  Protected DragMode As DragCode = DragCode.None

  ' New ---------------------------------------------------------------------------------
  '     Konstruktor
  ' -------------------------------------------------------------------------------------
  Sub New(ByVal Canvas As System.Windows.Forms.Form)
    Me.Canvas = Canvas
    qc = New QCard32Pool(Canvas.Handle)
    qc.SetDefaultValues()
    qc.SetOffSet(qc.Offset)
  End Sub

  ' Back --------------------------------------------------------------------------------
  '      Lesen/Festlegen der Kartenrckseite
  ' -------------------------------------------------------------------------------------
  Public Property Back() As Integer
    Get
      Return qc.BackNr
    End Get
    Set(ByVal Value As Integer)
      qc.BackNr = Value
      qc.SetCurrentBack(Value)
    End Set
  End Property

  ' --- Starten eines neuen Spieles : Initwerte, Mischen, Auslegen ---
  Public MustOverride Sub SpielStarten(ByVal SpielNr%)
  ' --- Wiederherstellen des aktuellen Kartenbildes ------------------
  Public MustOverride Sub Refresh()
  ' --- Starten des Ziehens einer Karte ------------------------------
  Public MustOverride Sub StartZiehen(ByVal X%, ByVal Y%)
  ' --- Fortsetzen des Ziehens einer Karte oder Kartenfolge ----------
  Public MustOverride Sub WeiterZiehen(ByVal X%, ByVal Y%)
  ' --- Beenden des Ziehen : Ablegen bzw. Rcklegen ------------------
  Public MustOverride Sub EndeZiehen(ByVal X%, ByVal Y%)
  ' --- Prfen und ggf. Ablegen --------------------------------------
  Public MustOverride Sub KarteAblegen()

End Class